<?php

namespace Blog\Controller;

use Blog\Model\GutscheinModel;

class GutscheinController {

    private $model;
    private $view;

    public function __construct($view) {
        $this->model = new GutscheinModel();
        $this->view = $view;
    }

    public function showGutscheine() {
        $gutscheine = $this->model->getGutscheine();
        $this->view->setVars(['gutscheine' => $gutscheine]);
    }

    public function createGutschein() {
        $data = [
            'code' => $_POST['code'] ?? null,
            'rabatt' => $_POST['rabatt'] ?? null,
            'eventid' => $_POST['eventid'] ?? null,
            'gültigkeit' => $_POST['gültigkeit'] ?? null
        ];
        $erg = $this->model->createGutschein($data);
        $this->view->setVars(['gutschein' => $erg]);
        exit;
    }

    public function editGutscheinForm() {
        $id = $_GET['gutscheinid'];
        if ($id) {
            $gutschein = $this->model->getGutschein($id);
            $this->view->setVars(['gutschein' => $gutschein]);
        }
    }

    public function updateGutschein() {
            $id = $_POST['gutscheinid'];
            $data = [
                'code' => $_POST['code'] ?? null,
                'rabatt' => $_POST['rabatt'] ?? null,
                'eventid' => $_POST['eventid'] ?? null,
                'gültigkeit' => $_POST['gültigkeit'] ?? null
            ];
            $this->model->updateGutschein($id, $data);
    }

    public function deleteGutschein() {
        $id = $_GET['gutscheinid'] ?? null;
        $this->model->deleteGutschein($id);
    }
}